"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var store_1 = require("../utils/store");
var meta_1 = require("../utils/meta");
var MetaReducer = /** @class */ (function () {
    function MetaReducer() {
    }
    MetaReducer.record = function (name) {
        if (MetaReducer.stash[name]) {
            store_1.getStore().dispatch({
                type: MetaReducer.RESTORE,
                payload: {
                    name: name,
                    data: MetaReducer.stash[name],
                },
            });
            delete MetaReducer.stash[name];
        }
        MetaReducer.usedNames.add(name);
    };
    MetaReducer.addCase = function (name, types) {
        MetaReducer.metaPrepare[types.prepare] = name;
        MetaReducer.metaSuccess[types.success] = name;
        MetaReducer.metaFail[types.fail] = name;
    };
    MetaReducer.getData = function (name) {
        return store_1.getState()[MetaReducer.reducerName][name];
    };
    MetaReducer.createData = function () {
        var _a;
        if (MetaReducer.isAppend) {
            return {};
        }
        MetaReducer.isAppend = true;
        return _a = {},
            _a[MetaReducer.reducerName] = function (state, action) {
                var _a;
                if (state === undefined) {
                    return {};
                }
                if (action.type === MetaReducer.RESTORE) {
                    return tslib_1.__assign(tslib_1.__assign({}, state), (_a = {}, _a[action.payload.name] = action.payload.data, _a));
                }
                var name;
                name = MetaReducer.metaPrepare[action.type];
                if (name) {
                    return MetaReducer.modifyReducer(state, name, action, true);
                }
                name = MetaReducer.metaSuccess[action.type];
                if (name) {
                    return MetaReducer.modifyReducer(state, name, action, false);
                }
                name = MetaReducer.metaFail[action.type];
                if (name) {
                    return MetaReducer.modifyReducer(state, name, action, false);
                }
                return state;
            },
            _a;
    };
    MetaReducer.modifyReducer = function (state, name, action, isLoading) {
        var _a, _b, _c;
        switch (action.metaKey) {
            case true:
                var meta = {
                    actionType: action.type,
                    loading: isLoading,
                    message: action.message,
                    httpStatus: action.httpStatus,
                    businessCode: action.businessCode,
                };
                if (MetaReducer.usedNames.has(name)) {
                    return tslib_1.__assign(tslib_1.__assign({}, state), (_a = {}, _a[name] = meta, _a));
                }
                MetaReducer.stash[name] = meta;
                return state;
            case false:
                return state;
            default:
                var singleMeta = {
                    actionType: action.type,
                    loading: isLoading,
                    message: action.message,
                    httpStatus: action.httpStatus,
                    businessCode: action.businessCode,
                };
                if (MetaReducer.usedNames.has(name)) {
                    return tslib_1.__assign(tslib_1.__assign({}, state), (_b = {}, _b[name] = tslib_1.__assign(tslib_1.__assign(tslib_1.__assign({}, state[name]), (_c = {}, _c[action.metaKey] = singleMeta, _c)), meta_1.METAS_PICK_METHOD), _b));
                }
                MetaReducer.stash[name] = MetaReducer.stash[name] || tslib_1.__assign({}, meta_1.METAS_PICK_METHOD);
                MetaReducer.stash[name][action.metaKey] = singleMeta;
                return state;
        }
    };
    MetaReducer.reducerName = '__metas__';
    MetaReducer.isAppend = false;
    MetaReducer.metaPrepare = {};
    MetaReducer.metaSuccess = {};
    MetaReducer.metaFail = {};
    MetaReducer.usedNames = new Set();
    MetaReducer.stash = {};
    MetaReducer.RESTORE = 'ReduxModel/LazyMeta';
    return MetaReducer;
}());
// Register metas automatically
store_1.appendReducers(MetaReducer.createData());
exports.default = MetaReducer;
