import { Action, DeepPartial, Reducer, Store, StoreEnhancer } from 'redux';
import { Reducers } from './types';
import { PersistStorage } from '../../libs/types';
import { BaseModel } from '../BaseModel';
export interface ReduxStoreConfig<S = any, A extends Action = Action> {
    reducers?: Reducers;
    enhancer?: StoreEnhancer;
    preloadedState?: DeepPartial<S>;
    onCombineReducers?: (reducer: Reducer<S, A>) => Reducer<S, A>;
    persist?: false | {
        version: string | number;
        key: string;
        storage: PersistStorage;
        whitelist: Record<string, BaseModel<any>>;
        restoreDelay?: number;
    };
}
export declare const watchEffectsReducer: (reducerName: string, className: string) => void;
export declare const appendReducers: (reducers: Reducers) => void;
export declare function createReduxStore<S = any>(config: ReduxStoreConfig<S>): Store<S>;
export declare const getStore: () => Store<any, import("redux").AnyAction>;
export declare const getState: () => any;
export declare const onStoreCreated: (fn: (store: Store<any, import("redux").AnyAction>) => void) => void;
